<template>
  <td :class="$style.tableCell">
    <base-icon
      :class="$style.editInputIcon"
      :name="properIcon"
      v-if="isEditable"
      @onClick="handleCellClick"
    ></base-icon>
    <base-input
      :class="$style.editCellInput"
      v-if="editCell"
      :name="name"
      :defaultValue="inputDefaultValue"
      @onChange="onInputChange"
    />
    <slot v-if="!editCell"></slot>
  </td>
</template>

<script lang="ts">
import Vue from "vue";
// @ts-ignore
import BaseInput from "@/components/base/BaseInput";
// @ts-ignore
import BaseIcon from "@/components/base/BaseIcon";

export default Vue.extend({
  name: "TableCell",
  components: {
    BaseInput,
    BaseIcon
  },
  props: {
    isEditable: {
      type: Boolean,
      required: false,
      default: false
    },
    name: {
      type: [Number, String],
      required: false
    }
  },
  data: function() {
    return {
      editCell: false
    };
  },
  computed: {
    inputDefaultValue: function() {
      return this.$slots &&
        this.$slots.default &&
        this.$slots.default[0].elm &&
        // toDo: find better solution for show text
        this.$slots.default[0].elm.innerText
        ? this.$slots.default[0].elm.innerText
        : "";
    },
    properIcon: function() {
      // @ts-ignore
      return this.editCell ? "flopy-o" : "edit";
    }
  },
  methods: {
    handleCellClick: function() {
      if (this.isEditable) {
        // @ts-ignore
        this.editCell = !this.editCell;
      }
    },
    onInputChange: function() {
      // console.log(input value)
    }
  }
});
</script>

<style module lang="scss">
.tableCell {
  padding: 1rem;
  position: relative;
}
.editInputIcon {
  position: absolute;
  z-index: 2;
  right: 10px;
  top: 0.8rem;
  color: $color--primary;
}
.editCellInput {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  box-shadow: none;
  box-sizing: border-box;
  width: 100%;
  max-width: 100%;
  border: 1px solid $color--border;
  min-height: 2rem;
}
</style>
